*+
*+
*+    Source Module => RESTRUC6.PRG
*+
*+    Functions: Function Restructure()
*+               Static Function Modify()
*+               Static Function TempName()
*+               Static Function NToSZ()
*+               Static Function ReplAll()
*+               Static Function RootName()
*+               Static Function DispMsg()
*+               Static Function ClrMsg()
*+
*+    Reformatted by Click! 1.13b3 on May-24-1998 at  6:58 pm
*+
*+

#include "fileio.ch"
#include "dbstruct.ch"
#include "setcurs.ch"
#include "box.ch"

#define DBFEXT ".DBF"
#define DBFBKP ".DBK"
#define MEMEXT ".DBT"
#define MEMBKP ".TBK"
#define FAILED .F.
#define SUCCESS .T.
// #define RESTTEST

#ifdef RESTTEST
//  ======================================================================== *
local abEval1  := { { || dbdelete() }, { || "V" $ upper( vendor ) } }
local abEval2  := { { || FIELD->vendor := lower( FIELD->vendor ) } }
local abCopy   := { { || FIELD->vndrfld := FIELD->vendor } }
local aChanges := { ;
                    { "ADD", "VENDOR", { "TEST2", "C", 20, 0 } }, ;
                    { "SIZE", "VENDOR", { "VENDOR", 60, 0 } }, ;
                    { "DEL", "VENDOR", { "EXT1" } }, ;
                    { "BLOCK", "VENDOR", abEval1 }, ;
                    { "BLOCK", "VENDOR", abEval2 }, ;
                    { "size", "vendor", { "ext2", 1, 0 } } }
local aOldRename := { ;
                      { "ADD", "VENDOR", { "VNDRFLD", "C", 20, 0 } }, ;
                      { "BLOCK", "VENDOR", abCopy }, ;
                      { "DEL", "VENDOR", { "VENDOR" } } }
local aRename := { { "RENAME", "VENDOR", { "VENDOR", "VENDFLD" } } }
//  Restructure( aOldRename )
if Restructure( aChanges )
   if Restructure( aRename )
      aWindow := DispMsg( "ALL CHANGES MADE SUCCESSFULLY!" )
      ALLKEY( 0 )
      ClrMsg( aWindow )
   endif
endif
#endif
//  ======================================================================== *
//  Structure of an element in aChanges:
//     { "ADD",    cTable, { cName, cType, nLen, nDec } }
//     { "DEL",    cTable, { cName } }
//     { "SIZE",   cTable, { cName, nLen, nDec } }
//     { "BLOCK",  cTable, { bProcess, bFor, bWhile, nNext, nRecno, lRest } }
//     { "RENAME", cTable, { cOldName, cNewName } }

*+
*+
*+    Function Restructure()
*+
*+    Called from ( restruc6.prg )   2 - 
*+
*+
*+
function Restructure( aChanges )

local nCntr    := 0
local aDbfList := {}
local lSuccess := SUCCESS
local cRoot    := ""
local lValid   := valtype( aChanges ) == "A"
local nSaveCrs := setcursor( SC_NONE )
local aWindow  := {}
local cOption
local cField
local bSave
local nCheck   := 0
local cCopy

if lValid
   nCheck ++
   lValid := .T.
   aeval( aChanges, { | x | lValid := if( valtype( x ) == "A", lValid, .F. ) } )
endif
if lValid
   nCheck ++
   aeval( aChanges, { | x | lValid := if( len( x ) == 3, lValid, .F. ) } )
endif
if lValid
   nCheck ++
   aeval( aChanges, { | x | lValid := if( valtype( x[ 1 ] ) == "C", lValid, .F. ) } )
endif
if lValid
   aeval( aChanges, { | x | x[ 1 ] := upper( x[ 1 ] ) } )
   nCheck ++
   aeval( aChanges, { | x | lValid := if( ascan( { "ADD", "DEL", "SIZE", "BLOCK", "RENAME" }, x[ 1 ] ) > 0, lValid, .F. ) } )
endif
if lValid
   nCheck ++
   aeval( aChanges, { | x | lValid := if( valtype( x[ 2 ] ) == "C", lValid, .F. ) } )
endif
if lValid
   aeval( aChanges, { | x | x[ 2 ] := upper( x[ 2 ] ) } )
   nCheck ++
   aeval( aChanges, { | x | lValid := if( valtype( x[ 3 ] ) == "A", lValid, .F. ) } )
endif

if !lValid
   alert( "Restructure aborted;Parameters invalid;Check No:" + str( nCheck, 1 ) )
   lSuccess := FAILED
else

   for nCntr := 1 to len( aChanges )

      //  Copy the database and memo file.
      cRoot := RootName( aChanges[ nCntr, 2 ] )
      if nCntr == 1
         aWindow := DispMsg( "Modifying: " + cRoot + DBFEXT )
      else
         if cRoot != RootName( aChanges[ nCntr - 1, 2 ] )
            ClrMsg( aWindow )
            aWindow := DispMsg( "Modifying: " + cRoot + DBFEXT )
         endif
      endif
      if ascan( aDbfList, { | x | x[ 1 ] == cRoot } ) == 0
         cCopy := RootName( TempName() )
         aadd( aDbfList, { cRoot, cCopy } )

         bSave := errorblock( { | x | break( x ) } )
         begin sequence
            COPY file ( cRoot + DBFEXT ) to ( cCopy + DBFEXT )
            if file( cRoot + MEMEXT )
               COPY file ( cRoot + MEMEXT ) to ( cCopy + MEMEXT )
            endif
         recover
            alert( "ERROR: Cannot create backup file(s) for;" + cRoot + DBFEXT )
            asize( aDbfList, len( aDbfList ) - 1 )
            lSuccess := FAILED
         end sequence
         errorblock( bSave )
      endif

      if lSuccess
         lSuccess := Modify( aChanges[ nCntr ], cCopy )
      endif

      //  Check for failure, and exit loop if found.
      if !lSuccess
         nCntr := len( aChanges ) + 1
      endif
   next
   if !empty( aWindow )
      ClrMsg( aWindow )
   endif

   //  Delete surplus files
   for nCntr := 1 to len( aDbfList )
      cRoot := aDbfList[ nCntr, 1 ]
      cCopy := aDbfList[ nCntr, 2 ]
      if lSuccess
         //  Rename temporary files to permanent name
         delete file ( cRoot + DBFEXT )
         rename( cCopy + DBFEXT ) to ( cRoot + DBFEXT )
         if file( cCopy + MEMEXT )
            delete file ( cRoot + MEMEXT )
            rename( cCopy + MEMEXT ) to ( cRoot + MEMEXT )
         endif
      else
         //  Delete temporary files
         if file( cCopy + DBFEXT )
            delete file ( cCopy + DBFEXT )
            if file( cCopy + MEMEXT )
               delete file ( cCopy + MEMEXT )
            endif
         endif
      endif
   next
endif

setcursor( nSaveCrs )
return ( lSuccess )

*+
*+
*+    Static Function Modify()
*+
*+    Called from ( restruc6.prg )   1 - function restructure()
*+
*+
*+
static function Modify( aChange, cCopy )

local cOption   := upper( aChange[ 1 ] )
local cFileName := cCopy + DBFEXT
local aFldStru
local cField
local cNewField
local bSave
local cTitle
local aOldStru
local nOldFlds
local nNewFlds
local nOldRecs
local nNewRecs
local nPointer
local cTempName
local aProgress
local nRecNum
local bEval
local lSuccess  := .T.

if cOption == "BLOCK"
   bEval := aclone( aChange[ 3 ] )
else
   aFldStru := aclone( aChange[ 3 ] )
   if cOption == "RENAME"
      cNewField := upper( aFldStru[ 2 ] )
   endif
   cField := upper( aFldStru[ 1 ] )
endif

bSave := errorblock( { | x | break( x ) } )
begin sequence
   dbusearea( .T.,, cFileName, "XX_Table", .F. )
recover
   alert( "Cannot open file;" + cFileName )
   return ( FAILED )
end sequence
errorblock( bSave )

aOldStru := XX_Table->( dbstruct() )
nOldFlds := XX_Table->( fcount() )
nOldRecs := XX_Table->( lastrec() )

if empty( nOldFlds )
   alert( "Unable to query original structure of;" + cFileName )
   XX_Table->( dbclosearea() )
   return ( FAILED )
endif

//  Check for presence of nominated field.
if cField != NIL
   nPointer := ascan( aOldStru, { | aVal | aVal[ 1 ] == cField } )
endif

//  Apply changes.
do case
case cOption == "RENAME"
   if ( nPointer == 0 )
      alert( "Field " + cField + " cannot be renamed;It does not exist" )
      lSuccess := .F.
   endif
   aOldStru[ nPointer, DBS_NAME ] := cNewField
   nNewFlds                       := nOldFlds
   cTitle                         := "Renaming: " + cField + " to " + cNewField
case cOption == "BLOCK"
   asize( bEval, 6 )
   XX_Table->( dbeval( bEval[ 1 ], bEval[ 2 ], bEval[ 3 ], bEval[ 4 ], bEval[ 5 ], bEval[ 6 ] ) )
   nNewFlds := nOldFlds
   cTitle   := "Block operation"
case cOption == "SIZE"
   if ( nPointer == 0 )
      alert( "Field " + cField + " cannot be re-sized;It does not exist" )
      XX_Table->( dbclosearea() )
      return ( FAILED )
   endif
   //  Has it already been re-sized?
   if aOldStru[ nPointer, DBS_LEN ] == aFldStru[ 2 ]
      if aOldStru[ nPointer, DBS_DEC ] == aFldStru[ 3 ]
         //  The change has already been made.
         XX_Table->( dbclosearea() )
         return ( SUCCESS )
      endif
   endif
   //  Change is yet to be made.
   aOldStru[ nPointer, DBS_LEN ] := aFldStru[ 2 ]
   aOldStru[ nPointer, DBS_DEC ] := aFldStru[ 3 ]
   nNewFlds                      := nOldFlds
   cTitle                        := "Resizing field: " + cField

case cOption == "ADD"
   if ( nPointer > 0 )
      //  Field already exists.
      XX_Table->( dbclosearea() )
      return ( SUCCESS )
   endif
   aadd( aOldStru, aFldStru )
   nNewFlds := nOldFlds + 1
   cTitle   := "Adding field: " + cField

case cOption == "DEL"
   if ( nPointer == 0 )
      //  Field already removed.
      lSuccess := .F.
   endif
   adel( aOldStru, nPointer )
   asize( aOldStru, len( aOldStru ) - 1 )
   nNewFlds := nOldFlds - 1
   cTitle   := "Deleting field: " + cField

otherwise
   alert( "Invalid operation: " + cOption )
   lSuccess := .F.

endcase

if !lSuccess
   XX_Table->( dbclosearea() )
   return ( FAILED )
endif

cTempName := TempName()
dbcreate( cTempName, aOldStru )
dbusearea( .T.,, cTempName, "TempFile", .F. )

if TempFile->( fcount() ) != nNewFlds
   alert( "Field Structure Update Failed" )
   lSuccess := .F.
endif

if lSuccess
   cTitle    += "  --  Records copied (percentage)"
   aProgress := INIT_PROGRESS( 22, nOldRecs, cTitle )
   for nRecNum := 1 to nOldRecs
      PROGRESS( aProgress )
      XX_Table->( dbgoto( nRecNum ) )
      TempFile->( dbappend() )
      if ReplAll( "XX_Table", "TempFile", cNewField, ( cOption == "DEL" ) )
         if XX_Table->( deleted() )
            TempFile->( dbdelete() )
         endif
      else
         nRecNum  := nOldRecs + 1       // Force exit from loop
         lSuccess := .F.
      endif
   next
   KILL_PROGRESS( aProgress )
endif

if lSuccess
   nNewRecs := TempFile->( lastrec() )
   lSuccess := ( nNewRecs == nOldRecs )
endif

TempFile->( dbclosearea() )
XX_Table->( dbclosearea() )

if !lSuccess
   alert( "Append from Original Table Failed" )
   delete file ( cTempName + DBFEXT )
   delete file ( cTempName + MEMEXT )
   return ( FAILED )
endif

//  Success, so copy modified file(s) over unmodified file(s).
delete file ( cCopy + DBFEXT )
rename( cTempName + DBFEXT ) to ( cCopy + DBFEXT )

if file( cCopy + MEMEXT )
   delete file ( cCopy + MEMEXT )
   rename( cTempName + MEMEXT ) to ( cCopy + MEMEXT )
endif

return ( SUCCESS )

*+
*+
*+    Static Function TempName()
*+
*+    Called from ( restruc6.prg )   1 - function restructure()
*+                                   1 - static function modify()
*+
*+
*+
static function TempName()

local nNewNo := seconds()

do while file( "TMP" + NToSZ( nNewNo, 5 ) + ".*" )
   nNewNo ++
enddo

return ( "TMP" + NToSZ( nNewNo, 5 ) )

*+
*+
*+    Static Function NToSZ()
*+
*+    Called from ( restruc6.prg )   2 - static function tempname()
*+
*+
*+
static function NToSZ( nVal, nLen )

return ( right( replicate( "0", nLen ) + ltrim( str( nVal, nLen ) ), nLen ) )

*+
*+
*+    Static Function ReplAll()
*+
*+    Called from ( restruc6.prg )   1 - static function modify()
*+
*+
*+
static function ReplAll( cSource, cDest, cNewField, lDeleting )

local nFieldCnt  := ( cSource )->( fcount() )
local xOldVal
local nNewPos
local cFldName
local nFieldNo
local nRenamePos := 0

if !empty( cNewField )
   nRenamePos := ( cDest )->( fieldpos( cNewField ) )
endif

for nFieldNo := 1 to nFieldCnt
   xOldVal  := ( cSource )->( fieldget( nFieldNo ) )
   cFldName := ( cSource )->( fieldname( nFieldNo ) )
   nNewPos  := ( cDest )->( fieldpos( cFldName ) )
   if nNewPos == 0
      //  Renaming
      nNewPos := nRenamePos
   endif
   if nNewPos > 0
      ( cDest )->( fieldput( nNewPos, xOldVal ) )
   else
      if !lDeleting
         return ( FAILED )
      endif
   endif
next

return ( SUCCESS )

*+
*+
*+    Static Function RootName()
*+
*+    Called from ( restruc6.prg )   3 - function restructure()
*+
*+
*+
static function RootName( cFileName )

local cRoot := cFileName
local cPath := ""
if "\" $ cRoot
   cPath := left( cRoot, rat( "\", cRoot ) )
   cRoot := substr( cRoot, rat( "\", cRoot ) + 1 )
endif
if "." $ cRoot
   cRoot := left( cRoot, rat( ".", cRoot ) - 1 )
endif
cRoot := cPath + cRoot

return ( upper( cRoot ) )

*+
*+
*+    Static Function DispMsg()
*+
*+    Called from ( restruc6.prg )   1 - 
*+                                   2 - function restructure()
*+
*+
*+
static function DispMsg( cText )

local nTop     := int( ( maxrow() - 4 ) / 2 )
local nBtm     := nTop + 4
local nLft     := int( ( maxcol() - 4 - len( cText ) ) / 2 )
local nRyt     := nLft + 3 + len( cText )
local aSaveScr := { nTop, nLft, nBtm, nRyt, savescreen( nTop, nLft, nBtm, nRyt ) }

@ nTop, nLft, nBtm, nRyt box B_DOUBLE + " " color "w+/b"                     
@ nTop + 2, nLft + 2                        say cText    color "w+/b"        

return ( aSaveScr )

*+
*+
*+    Static Function ClrMsg()
*+
*+    Called from ( restruc6.prg )   1 - 
*+                                   2 - function restructure()
*+
*+
*+
static function ClrMsg( aWindow )

restscreen( aWindow[ 1 ], aWindow[ 2 ], aWindow[ 3 ], aWindow[ 4 ], aWindow[ 5 ] )

return ( NIL )

*+ EOF: RESTRUC6.PRG
